
/********************************************
Copyright Pavel Potapov, 2013-2016
distributed under GNU General Public License
********************************************/

//BELOW THERE ARE EXAMPLES OF USING 
//extended UIFrames112 (wrap around UIFrame)
//and extended Frames112 (wrap around Image object)
 
class GrandChild: ChildUIFrame112
{
//This class is an example of redrawn frame
//The number of input lines can be changed by User with redrawing the frame
//Note that the UIFrame object is NOT destroyed during redrawing

number NumberLines 	//how many input lines are presently in UIFrame
image Values		//1D array of "NumberLines" dimension

//DLG tags
TagGroup DLGtags(object self)
	{
	//This DLG tags are of fixed length	
	taggroup FixedGroup = DLGCreateBox("")	
	FixedGroup.DLGAddElement(DLGCreatePushButton("Add line", "Add"))
	FixedGroup.DLGAddElement(DLGCreatePushButton("Remove line", "Remove"))
	FixedGroup.DLGAddElement(DLGCreatePushButton("Print", "Print"))
	
	//This DLG tags are of variable length
	TagGroup VariableGroup = DLGCreateDialog("").DLGTableLayout(2,NumberLines,0)
	for(number i=1;i<=NumberLines;i++)
		{
		VariableGroup.DLGAddElement(DLGCreateLabel("     INPUT LINE "+i))
		//values are taken from the pre-stored array
		number Val = getPixel(Values,i-1,0);
		VariableGroup.DLGAddElement(DLGCreateIntegerField(Val,8).DLGIdentifier("line"+i))
		}

	//compose them both
	taggroup Dialog = DLGCreateBox("")	
	Dialog.DLGAddElement(FixedGroup)
	Dialog.DLGAddElement(VariableGroup)


	return Dialog 
	}

//The essential part of the redrawing UIFrames
//this methodName is STANDARD and interfaced (not change the name)
//This method can be call either from "init" or from "Redrawer112" object	
void RedrawnUIFrame112(object self) 
	{
	self.initUIFChild112(self.GetMotherID(),self.DLGtags(),self.GetPackageName(),self.GetFrameName())
	}

//Frame initialization	
void init(object self,number motherID,string Name)
	{
	NumberLines = 1	
	Values:= integerImage("",1,0,NumberLines,1)
	
	self.SetMotherID(motherID) 
	self.SetFrameName(Name) //needed because UIFrame112 displayed through redrawer
	
	//to draw first variant of frame 
	self.RedrawnUIFrame112()	
	}

//This changes the number of input lines 
void ChangeNumberOfInputLines(object self) 
	//redraw the variable DLG group
	{
	//stores the previous values in the array
	if(NumberLines>0) Values:= integerImage("",1,0,NumberLines,1)
	for(number i=1;i<=NumberLines;i++)
		{	
		try{Values.setPixel(i-1,0,self.LookUpElement("line"+i).DLGGetValue());} catch{break;}
		}
	
	//lanch the redrawer object
	alloc(DLGredrawer112).init(self.ScriptObjectgetID()).StartThread("Go")
	}

//Add one more input line	
void Add(object self) 
	//add one line to variable DLG group
	{		
	NumberLines++
	self.ChangeNumberOfInputLines()
	}

//Delete one  input line
void Remove(object self) 
	//remove one line to variable DLG group
	{	
	NumberLines--
	self.ChangeNumberOfInputLines()
	}
	
//Print out in result the content of the input lines	
void Print(object self) 
	{	
	for(number i=1;i<=NumberLines;i++)
		{
		result("\nline"+i+" "+self.LookUpElement("line"+i).DLGGetValue() )
		}
	}

number AboutToCloseUIFrame112(object self, number verify) 
	{
	//add here some actions you like to proceed when the UIFrame is about to be closed
	return 1
	}
	
void CloseUIFrame112(object self)
	{	
	//add here some actions you like to proceed when this object is closed
	}	
		
}


class Child: ChildUIFrame112
{
//This class is an example of how to create live images and its childs with Frame112 wrap around image
//Note that the positions and zooms of the created images are preserved when lunched again later.
//FFT image is closed automatically when the origin live image is closed
//Also demonstrates graphical buttons of UIFrame112

number liveID		//live image ID
number width,height	//size of live image

number running	//running = 0 : not started yet
				//running = 1 : runs
				//running = 2 : paused
				
number delay	//controls running speed

ImageDocument FFTdoc	

//DLG Tags
TagGroup CreateDLG(object  self)
	{
	TagGroup Dialog = DLGCreateDialog("")
	
	//make graphical version of string using GraphicFromString
			//define content, size, background  and style of caption
			string caption = "child window"
			number size = 20
			string font = ""
			number Face = 2
			number Bcgrd = 240			
		image GraphCaption = self.GraphicFromString(caption,size,font,face,Bcgrd) //graphical caption from string
	Dialog.DLGAddElement(DLGAddBitmap(DLGCreateGraphic(8*size,2*size),GraphCaption))

	//graphical buttons using Button112 and Icons names
			//define size, background and borders of buttons
			size = 16
			Bcgrd = 210
			number borderWidth = 2
		TagGroup Buttons = DLGCreateDialog("").DLGTableLayout(3,2,0) 

		Buttons.DLGAddElement(self.Button112(self.Iplay(size,Bcgrd,borderWidth),"ActionPlay"))
		Buttons.DLGAddElement(self.Button112(self.Ipause(size,Bcgrd,borderWidth),"ActionPause"))
		Buttons.DLGAddElement(self.Button112(self.Iarrow(1,size,Bcgrd,borderWidth),"ActionUp"))
		
		Buttons.DLGAddElement(self.Button112(self.GraphicFromString("FFT",size,"",1,Bcgrd),"ActionFFT"))
		Buttons.DLGAddElement(DLGcreateLabel(""))
		Buttons.DLGAddElement(self.Button112(self.Iarrow(3,size,Bcgrd,borderWidth),"ActionDown"))	
	
	Dialog.DLGAddElement(Buttons)
	
	Dialog.DLGAddElement(DLGCreateLabel(" "))
	Dialog.DLGAddElement(DLGCreatePushButton("open GrandChild", "CreateGrandChild"))

	return Dialog
	}
	
//Frame initialization	
void init(object self,number motherID,string Name)
	{
	string package = motherID.GetScriptObjectFromID().GetPackageName()

	self.initUIFChild112(motherID,self.CreateDLG(),package,Name)

	}

//This running thread simulates some periodical changes in in Live image
//the changes speed can be varied by pressing arrows buttons	
void Thread2(object self)
	{		
	//this is what should be done in background
	number maxCycles = 10
	number steps = 100
	number step = 1/steps
	delay = 0.1 	//(in sec)
	number fract

	try	//this is needed to treat exception in thread
	{	
	for(number i=0;i<Steps*maxCycles;i++)
		{
		image im:= liveID.getimageFromID()
		
		fract += step
		if(fract>1) fract = 0
//result("\nfract "+fract)
		im = tert(iradius <fract*width/2,1,0)
		
		while(running==2) {;}
		sleep(delay)
		}
	//end of what should be done in background
	}
	catch 
		{
		result("\nimage was probaly deleted")
		break	
		}
		
running = 0

try{
	image im:= liveID.getimageFromID()
	im.deleteimage()
	}
catch{break;}
	
result("\nlive image finished")			
	}
	
//start live image	
void ActionPlay(object self)
	{
result("\nPlay pressed")
	
	if(running==0)
		{
		width=256
		height=256
		image liveIm:=integerImage("Live",1,0,width,height)
		liveID = Liveim.ImageGetID()
		LiveIm.showimage()
		
		imageDocument livedoc = liveIm.ImageGetOrCreateImageDocument()
		documentWindow livewin = livedoc.ImageDocumentGetWindow()

		if(!alloc(Frame112).initFrame112(livedoc,self.GetPackageName(),"Live")) 
		throw("Frame112 must be initilised with opened Window !!")
		
		self.StartThread("Thread2")
		
		running = 1
		}
	else running = 1
	}

//Pause live image	
void ActionPause(object self)
	{
result("\nPause pressed")
	running = 2
	}

//increment the playing speed	
void ActionUp(object self)
	{
result("\nUp pressed")
	
	delay /= 1.5
	}

//decrement the playing speed	
void ActionDown(object self)
	{
result("\nDown pressed")
	delay *= 1.5
	}

//create live FFT image of the frontmost  image
void ActionFFT(object self)
	{
result("\nFFT pressed")

	if(!FFTdoc.CheckImageWindow112()) 
		{
		imageDocument imdoc = getFrontImageDocument()
		if(!imdoc.ImageDocumentIsvalid()) throw("No FrontImage to build FFT !!")

		documentWindow imwin = imdoc.ImageDocumentGetWindow()
		imagedisplay imdisp = imdoc.ImageDocumentGetImageModeDisplay()
		ROI sel = imdisp.ImageDisplayGetRoi(0)
		image FFTim := NewLiveFFT(imdisp,sel,0)
	
		FFTdoc = FFTim.ImageGetOrCreateImageDocument()
	
		if(!alloc(ChildFrame112).initChildFrame112(FFTdoc,imdoc,self.GetPackageName(),"fft")) throw("Cannot create live FFT !!")
		}
	else FFTdoc.ImageDocumentGetWindow().WindowSelect()
	}	


//open the grandchild UIFrame112 window	
void CreateGrandChild(object self)
	{
	object GrandChild = self.AllocFromDummyObject("GrandChild")
	GrandChild.init(self.ScriptObjectGetID(),"grand child")
	}


number AboutToCloseUIFrame112(object self, number verify) 
	{
	//add here some actions you like to proceed when the UIFrame is about to be closed
	return 1
	}
	
void CloseUIFrame112(object self)
	{	
	//add here some actions you like to proceed when this object is closed
	}	
}


class Mother: UIFrame112
{
//this class is an example of 
//		1) hierarhical lanching child frames from the mother one
			//Note that  childs UIFrames are automatically closed when the parents are closed
// 		2) lanching thread from UIFrame
			//Note that thread A is accompanied by the waiting icon, its "Start" button is disabled when running
			//Note that "Start", "Stop" buttons are enabled/disabled according the thread B running status
//		3) storing and loading parameters in global Tags

object DummyChild
object DummyGrandChild
object StoredRedrawer

number WaitingID //this is an ID of Waiting icon for thread2
number run1		//this number monitors whether the thread1 is running (1) or not (0)
image profile	//image to be updated by thread

number Param1 	//global parameters to be stored/loaded
string Name1 	//global parameters to be stored/loaded


//DLG Tags	
TagGroup CreateDLG(object self)
	{
	TagGroup Dialog = DLGCreateDialog("")
	
		TagGroup SettingsGroup = DLGCreateDialog("").DLGTableLayout(2,1,0)
		SettingsGroup.DLGAddElement(DLGCreateLabel("                                 "))
		SettingsGroup.DLGAddElement(self.settingsButton(20,210,"Settings"))
	Dialog.DLGAddElement(SettingsGroup)
	Dialog.DLGAddElement(DLGCreatePushButton("Start thread A", "StartThread2").DLGIdentifier("Start2"))
	Dialog.DLGAddElement(DLGCreatePushButton("Start thread B", "StartThread1").DLGIdentifier("Start1"))
	Dialog.DLGAddElement(DLGCreatePushButton("Stop thread B", "StopThread1").DLGIdentifier("Stop1").DLGEnabled(0))
	Dialog.DLGAddElement(DLGCreateLabel(" "))
	Dialog.DLGAddElement(DLGCreatePushButton("open Child", "CreateChild"))
	
	return Dialog
	}
		
void init(object self,string Package,string Name)
	{
	//initiallization
	if(!self.initUIFrame112(self.CreateDLG(),Package,Name)) exit(0)
	//this must be BEFORE loading parameters
	
	//loading global parameters from global Tags
	Param1 = self.LoadNumber112(5,"Parameter 1")
	Name1 = self.LoadString112("DEFAULT","Name 1")
result("\nParam1 "+Param1+" name1 "+name1)
	
	//loading local parameters from global Tags
	number X,Y,x1,y1,x2,y2
	self.LoadPoint112(X,Y,2,2,"Point 1")
	self.LoadRect112(x1,y1,x2,y2,3,3,4,4,"Rect 1")
result("\npoint ("+X+","+y+") rect ("+x1+","+y1+","+x2+","+y2+")")

	//storing global and local parameters in persistentTags
	self.StoreNumber112(Param1,"Parameter 1")
	self.StoreString112(Name1,"Name 1")
	self.StorePoint112(X,Y,"Point 1")
	self.StoreRect112(x1,y1,x2,y2,"Rect 1")
	
	//this dummy instances are needed to keep clasess definitions
	//dummy objects are created but not initialized 
	//alternatively you might install these classes as library
	DummyChild  = self.KeepClassInDummyObject(alloc(Child),"Child")
result("\ndummy Child "+ DummyChild .ScriptObjectgetID() +" stored")
	DummyGrandChild = self.KeepClassInDummyObject(alloc(GrandChild),"GrandChild")
result("\ndummy GrandChild "+ DummyGrandChild .ScriptObjectgetID() +" stored")

	}

//adjustment of global parameters	
void Settings(object self)
	{
	number NumberLines = 2		//number of adjusted parameters
	
	//1st parameter : number Param1
	TagGroup Param1T = DLGCreateIntegerField(Param1,3)
	string Param1Name = "Parameter 1"
	
	//2nd parameter : string Name1
	TagGroup Name1T = DLGCreateStringField(Name1,20)
	string Name1Name = "Name 1"
	
	//Compose DLG tags
	TagGroup SettingList = DLGCreateBox("Settings").DLGTableLayout(1,NumberLines,1)
	SettingList.DLGaddElement(self.SettingsLine(Param1Name,Param1T).DLGAnchor("East")) //SettingsLine is UIFrame112 
	SettingList.DLGaddElement(self.SettingsLine(Name1Name,Name1T).DLGAnchor("East")) //SettingsLine is UIFrame112 
	
	//open dialog
	object SettingsFrame = Alloc(UIframe).init(SettingList)
	if(SettingsFrame.Pose())
		{
		Param1 = self.SettingNumberParameter(Param1T,Param1Name) //SettingNumberParameter is UIFrame112
result("\nadjusted: "+Param1) 
		Name1 = self.SettingStringParameter(Name1T,Name1Name) //SettingStringParameter is UIFrame112
result("\nadjusted: "+Name1) 
		}
	}

void StartThread2(object self)
	{
	WaitingID = self.StartThreadFromDLG("Thread2","Start2")	
	}
	
void thread2(object self)
	{
	number NumberCycles = 5
	
	for(number i=0;i<NumberCycles;i++)
		{
		result("\nCalculaztion step "+i)
		sleep(1)
		}
	
	self.EndThread("Start2",WaitingID)
	result("\nCalculaztion finished")	
	}
	
//start the thread by "Start" button
void StartThread1(object self)
	{
	Profile := integerimage("smaple",1,0,15,1)
	Profile.showimage()
	imageDocument ProfileDoc = Profile.ImageGetOrCreateImageDocument()

	if(!alloc(Frame112).initFrame112(ProfileDoc,self.GetPackageName(),"Profile")) 
	throw("Frame112 must be initilised with opened Window !!")
	
	self.RunThreadFromDLG("Thread1",run1,"Start1","Stop1")
		//Thread name (no parameters); start/stop button IDENTIFIERS
		//run1 must be GLOBAL number
	}

//stop the thread by "Stop" button	
void StopThread1(object self)
	{
	self.StopThreadFromDLG(run1,"Stop1")
	//GLOBAL thread running number; start/stop button IDENTIFIERS
	}
	  
//running thread1	
void Thread1(object self)
	{	
	try	//this is needed to treat exception in thread
	{	
	//this is what should be done in background

	for(number i=0;i<20;i++)
		{
		result("\nDO "+i)
		Profile.setPixel(i,0,i)
		//do something
		
	self.CheckStopFlag(run1,"Start1")	//insert that in every thread fragment
								//then thread will react on "stop" button when the fragment ends
		sleep(1)
		}
	//end of what should be done in background
	}
	catch 
		{
		result("\nstopped or failed")
		break	
		}
		
	self.TerminateThreadFromDLG(run1,"Start1","Stop1")	
	}

//open child frame	
void CreateChild(object self)
	{
	object Child = self.AllocFromDummyObject("Child")
	Child.init(self.ScriptObjectGetID(),"child")
	}

//thread is stopped when frame is closed	
number  AboutToCloseUIFrame112(object self, number verify) 
	{
	self.StopThread1()
	//add here some other actions you like to proceed when the UIFrame is about to be closed
	return 1
	}
	
void CloseUIFrame112(object self)
	{	
	//add here some actions you like to proceed when this object is closed
	}

}

//this command safely lanch the mother frame
void createAll()
{
object Mother = alloc(Mother)
Mother.init("_testScripts:scriptA","mother") 
//"_testScripts" is the name of the identificator of all yours private scripts
//to avoid mess in GlobalTags structure it is recommended to start with _ like "_John's_Scripts:...")
//"ScriptA" name of the specific script package 
//"mother" is the name of the specific frame in the package 
}

createAll()
