/********************************************
Copyright Pavel Potapov, 2013-2016
distributed under GNU General Public License
********************************************/

interface InterfaceExtendedFrames112
	{
	string GetPackageName(object self);			//needed for loading/storing parameters
	number AboutToCloseUIFrame112(object self, number verify); 	//may be defined by user
	void CloseUIFrame112(object self);			//may be defined by user
	void RemoveListenerFromMotherWindow112(object self);
					//defined in ChildUIFrame112 but must be used in UIFrame112
	void SafeCloseUIFrame112(object self);	//defined in UIFrame112 but useful everywhere
	object RedrawnUIFrame112(object self); //must be defined in userclass if redrawing needed
	void CloseWindowUser112(object self);	//may be defined by user
	void CloseFrame112(object self);		//may be defined by user
	number initChildFrame112(object self,ImageDocument imdoc,ImageDocument mothdoc,string PackageName,string Name);
					//used in UIFrame112 to start live FFT from frontmost image
	}				



/******************************************************************
Paramenters storing and loading
******************************************************************/

string getPackageName112(object frm)
	{
	if(frm.ScriptObjectIsValid()) 
		{
		string package
		try
			{package = frm.GetPackageName();}
		catch
			{throw("Object must be of type (UI)Frame112");}
			
		if(package=="") throw("(UI)Frame112 object name was not initiated")
	
		return package
		}
	}
	
//load  number
number LoadNumber112(object frm,number default,string ParameterName)
	{
	string package = frm.getPackageName112()
	number Parameter
	if(!getPersistentNumberNote(Package+":"+ParameterName,Parameter)) Parameter=Default;

	return Parameter
	}
	
//store  number
void StoreNumber112(object frm,number Parameter,string ParameterName)
	{
	string package = frm.getPackageName112()
	setPersistentNumberNote(Package+":"+ParameterName,Parameter)
	}

//Load the UIF32 number (0-4294967295)
number LoadID112(object frm,string ObjectName)
	{
	string package = frm.getPackageName112()
	
	TagGroup pers = GetPersistentTagGroup()
	
	number ID
	TagGroupGetTagAsUInt32(pers,Package+":"+ObjectName,ID)
	
	return ID
	}

//Store the UIF32 number (0-4294967295)
void StoreID112(object frm,number ID, string ObjectName)
	{
	string package = frm.getPackageName112()
	
	TagGroup pers = GetPersistentTagGroup()

	TagGroupSetTagAsUInt32(pers,Package+":"+ObjectName,ID)
	}
	
//load couple of numbers				
void LoadPoint112(object frm,number &Y,number &X,number defaultY,number defaultX,string ParameterName)
	{
	string package = frm.getPackageName112()
	if(!getPersistentPointNote(Package+":"+ParameterName, Y,X)) 
		{
		X = defaultX
		Y = defaultY
		}
	}

//this is loading the special point - position of Frame
void LoadFramePositions112(object frm,number &top,number &left, string Name)
	{
	//check the overall available area for frames
	number topD,leftD,bottomD,rightD
	DLGBuildPositionFromApplication().taggroupGetTagAsShortRect("Reference",topD,leftD,bottomD,rightD)
//result("\navailable "+topD+","+leftD+"->"+bottomD+","+rightD)
	//load the stored (UI)Frame112 position and check it

	frm.LoadPoint112(top,left,topD,leftD,Name+" TL")

	if((top==topD)&&(left==leftD)) result("\nNo stored Frame position")
	
	//top-left position above available area make Frame invisible
	if(top>bottomD){top=topD;result("\nstored top position is too large");}
	if(left>rightD){left=leftD;result("\nstored top position is too large");}
	}

//store  couple of numbers	(as for corner position)
void StorePoint112(object frm,number Y,number X,string ParameterName)
	{
	string package = frm.getPackageName112()
	setPersistentPointNote(Package+":"+ParameterName, Y,X) 
	}
				
//load four numbers (as for full position)	
void LoadRect112(object frm,number &Y1,number &X1,number &Y2,number &X2,number defaultX1,number defaultY1,number defaultX2,number defaultY2,string ParameterName)
	{
	string package = frm.getPackageName112()
	if(!getPersistentRectNote(Package+":"+ParameterName ,Y1,X1,Y2,X2)) 
		{
		X1 = defaultX1
		Y1 = defaultY1
		X2 = defaultX2
		Y2 = defaultY2
		}
	}

//store four numbers
void StoreRect112(object frm,number Y1,number X1,number Y2,number X2,string ParameterName)
	{
	string package = frm.getPackageName112()
	setPersistentRectNote(Package+":"+ParameterName, Y1,X1,Y2,X2) 
	}

//load string				
string LoadString112(object frm,string default,string ParameterName)
	{
	string package = frm.getPackageName112()
	string Name
	if(!getPersistentStringNote(Package+":"+ParameterName,Name)) Name=Default;
	return Name
	}

//store string
void StoreString112(object frm,string Name,string ParameterName)
	{
	string package = frm.getPackageName112()
	setPersistentStringNote(Package+":"+ParameterName,Name)
	}

/******************************************************************
Waiting icon 
******************************************************************/
	
class Wait112:UIFrame
{
number takt
number stop

image im1,im2,im3,im4

Image WaitIcon(object self,number sign,number rot,number size,number background)
	{
	number central = size/20
	number rad = size/2
	number kant = size/25
	
	image im:= integerimage("",1,0,size,size)
	im = background
	im = tert(((icol-size/2)*(irow-size/2)*sign)>central,0,im)
	if(rot) 
		{
		image rotated = im.rotate(3.14159/4)
		number offset = round(size*(sqrt(2)-1)/2)
		im = rotated[offset,offset,size+offset,size+offset]
		}
		
	im = tert(iradius>(rad-kant),0,im)
	im = tert(iradius>rad,background,im)
	
	return im
	}

image GetIcon(object self,number index)
	{
	if(index==1) return im1
	if(index==2) return im2
	if(index==3) return im3
	if(index==4) return im4
	}
		
TagGroup CreateDLG(object self,number size)
	{
	TagGroup Wait = DLGCreateDialog("")
	Wait.DLGAddElement(DLGAddBitmap(DLGCreateGraphic(size,size),im1).DLGIdentifier("Wicon"))
	Wait.DLGAddElement(DLGCreateLabel("wait ..."))
	
	return Wait
	}
	
void Waiting(object self)	
	{
	number index
	while(!stop)
		{
		index++
		sleep(takt)
		try{
		self.LookUpElement("Wicon").DLGGetElement(0).DLGBitmapData(self.GetIcon(index))	
			}
		catch{stop=1;break;}
	
		if(index==4) index = 0
		}
	}
		
void init(object self)	
	{
	takt = 0.1
	number size = 40
	number background = 210
	
	im1 = self.WaitIcon(1,0,size,background)
	im2 = self.WaitIcon(-1,1,size,background)
	im3 = self.WaitIcon(-1,0,size,background)
	im4 = self.WaitIcon(1,1,size,background)
	
	self.init(self.CreateDLG(size))
	display(self,"");
	
	number top,left,bottom,right
	TagGroup AppPositions = DLGBuildPositionFromApplication()
	AppPositions.TagGroupGetTagAsShortRect("Reference",top,left,bottom,right)
	self.GetFrameWindow().WindowSetFramePosition((left+right)/2,(top+bottom)/2)
	
	self.StartThread("Waiting")
	}
	
~Wait112(object self)	
	{
	result("\nwaiting object "+self.ScriptObjectGetID()+ " destroyed")
	}
}

				
/******************************************************************
Extended UIFrame
******************************************************************/
class UIFrame112: UIFrame
{
//This is a wrap around the UIFrame class
//Stores the position of the UIFrames
//Allows the hierarchial opening the child UIFrames
//Keeps the classes for object that should be created from UIFrames
//Easy and clean lanching threads from UIFrames
//stores and loads the script parameters
//some common graphic are added as library

	string Package	//this is name of whole package
	string Name		//this is name of specific frame (mother childs,grandChilds...)
	
	//function to load and output the standard names
	void SetFrameName(object self,string NameP) Name = NameP
	void SetPackageName(object self,string PackageP) Package = PackageP
	string GetFrameName(object self) return Name
	string GetPackageName(object self) return Package
	
/******************initialization and closing***************************/

//initialize frame at the pre-stored position and check if it was not open already	
number initUIFrame112(object self,TagGroup FrameTag,string PackageP,string NameP)
	{
	//set standard names
	self.SetPackageName(PackageP)
	self.SetFrameName(NameP)
					
	//check if already opened
	number FrameID = self.LoadID112(Name+" ID")	
	object temp = FrameID.GetScriptObjectFromID()
	if(temp.ScriptObjectIsValid()) {temp.GetFrameWindow().WindowSelect();return 0;} 
	//extended UIFRame allows only one instance of given class in given package to be opened
	//if it was already once opened, its window is selected while the new instance is closed
	else 
		{
		//if not opened initialize UIFrame
		self.init(FrameTag)
		display(self,Name);	
		
		//store frame ID in Tags
		self.StoreID112(self.ScriptObjectGetID(),Name+" ID")

		//load and set position of the UIFrame112					
		number top,left
		self.LoadFramePositions112(top,left,Name)

//result("\ntop "+top+ " left "+left)
		self.GetFrameWindow().WindowSetFramePosition(left,top) //Note that point defined as left,top in this command		
	
result("\n"+Name+" "+ self.ScriptObjectGetID() + " initialized")

		return 1	
		}			
	}

//close frame safely both in GMS1 and GMS2
void SafeCloseUIFrame112(object self) //universal for DM1.x and DM2.x
	{
	try{self.close();} catch{self.GetFrameWindow().WindowClose(0);break;}
	}	

//just before closing UIFrame	
//DO NOT OVERWRITE IT in the derived claases, use "AboutToCloseUIFrame112" instead !!!
number AboutToCloseDocument(object self, number verify )
	{
	//store window position in Tags
	number top,left
	Self.GetFrameWindow().WindowGetFramePosition(left,top) //Note that point defined as left,top in this command
//result("\ntop "+top+" left "+left)

	self.StorePoint112(top,left,Name+" TL")
	
	//remove window listener if mother DLG exist
	try{self.RemoveListenerFromMotherWindow112();} catch{break;}
				
	//fire higher level method if defined
	number verify
	try{self.AboutToCloseUIFrame112(verify);} catch{break;} 
	//AboutToCloseUIFrame112 maybe defined  if neccesary in classes derived from UIFrame112 
				
	//set frame ID in Tags to 0
	self.StoreID112(0,Name+" ID")
	}

//after closing UIFrame
~UIFrame112(object self) 
	{
	//fire higher level method if defined
	try{self.CloseUIFrame112();} catch{break;}
	//CloseUIFrame112 maybe defined if neccesary in classes derived from UIFrame112 
		
result("\n"+Name+" "+self.ScriptObjectGetID()+" destroyed") 		
	}


/************************Keep classes************************************/

//To prevent "forgetting" the defined class a dummy instance must be created
//This method stores the ID of dummy class
//NOTE THAT THE DUMMY OBJECT SHOULD BE KEPT AS GLOBAL In MOTHER OBJECT 
//OTHERWISE IT WILL IMMIDEATELY RUN OUT OF SCOPE AND CANNOT BE ADDRESSED ANYMORE
object KeepClassInDummyObject(object self,object DummyObject,string ClassName)
	{			
	try{
		DummyObject.SetFrameName("dummy "+ClassName)
		DummyObject.SetPackageName(Package)
		//make problem when allocating stored non-DLG classes
		}
	catch break

	self.StoreID112(DummyObject.ScriptObjectGetID(),"Kept Class:"+ClassName)
				
	return DummyObject
	}


//instance of stored class is created by cloning the dummy instance
object AllocFromDummyObject(object self,string ClassName)
	{
	//find the dummy instance
	number DummyObjectID = self.LoadID112("Kept Class:"+ClassName)
	
	//make new instance by cloning
	object temp = DummyObjectID.GetScriptObjectFromID()
	if(temp.ScriptObjectIsValid())
		{
		return temp.ScriptObjectClone()
		}
	else throw("Cannot find kept class "+ClassName+"\nThe dummy object probably run out of scope after initialization")	
	
	}


/******************** starting thread with waiting icon *******************/
//fire a thread from DLG with using "Start" 
//identifier of "Start" buttons is required	
//The waiting icon appears indicating the runnning process 
//Waiting ID is returned, this must be used ate the end of thread to close the waiting icon			
number StartThreadFromDLG(object self,string ThreadName,string StartButton)
	{
	self.SetElementIsEnabled(StartButton,0)
	object WaitingIcon = alloc(Wait112)
	WaitingIcon.init()
	self.StartThread(ThreadName)	

	return WaitingIcon.ScriptObjectgetID()			
	}
	
//this closes the waiting icon 
//"Start" control button is enabled 
//identifier of "Start" button is required				
void EndThread(object self,string StartButton,number WaitingID)
	{
	self.SetElementIsEnabled(StartButton,1)
	object WaitingIcon = WaitingID.GetScriptObjectFromID()	
	
	try{WaitingIcon.close();} catch{WaitingIcon.GetFrameWindow().WindowClose(0);break;}		
	}
	
	
/******************** starting a thread with posibility to stop it from DLG frame*******************/

//fire a thread from DLG with using "Start" 
//thread may be stopped with "Stop" control button 
//identifiers of both buttons are required				
void RunThreadFromDLG(object self,string ThreadName,number &run,string StartButton,string StopButton)
	{
	run = 1
	self.SetElementIsEnabled(StartButton,0)
	self.SetElementIsEnabled(StopButton,1)
	self.StartThread(ThreadName)				
	}

//stop a thread from DLG with using "Stop" control button
//"Start" button is not yet enabled because it might be too early to allow the new start of thread
// identifiers of "Stop" button is required	
void StopThreadFromDLG(object self,number &run,string StopButton)
	{
	run = 0
	self.SetElementIsEnabled(StopButton,0)
	}

//Start Button is enabled			
void RestoreStartButton(object self,number run,string StartButton)
	{
	if(run==0) 
		{
		self.SetElementIsEnabled(StartButton,1)
		}	
	}

//if "Stop" button is already pressed but thread is still busy with long calculations
//insert it within Try{}catch{} in the long calculation chain
//exception is generated and "Start" Button is enabled 
void CheckStopFlag(object self,number run,string StartButton)
	{
	if(run==0) 
		{
		self.RestoreStartButton(run,StartButton)
		image Err
		Err.setPixel(2,0,0)
		}	
	}
	
//Full termination of thread
//"Stop" and "Start" buttons are immediately set in the right state 	
void TerminateThreadFromDLG(object self,number &run,string StartButton,string StopButton)
	{
	run = 0
	self.SetElementIsEnabled(StopButton,0)
	self.RestoreStartButton(run,StartButton)
	}


/******************Graphics**********************/

image IRahm(object self,image in,number kantX,number kantY,number Bcgrd)
	{
	number W,H
	getSize(in,W,H)
	
	image Outlined:=integerImage("",1,0,W+2*kantX,H+2*kantY)
	Outlined = Bcgrd
	Outlined[kantY,kantX,kantY+H,kantX+W]=in
	
	return Outlined
	}

image Ibcgrd(object self,number size,number Bcgrd)
	{
	image im:=integerIMage("",1,0,size,size)	
	im=Bcgrd
	
	return im
	}
	
//This convert the input string into the graphical image with controlled font size and style				
image GraphicFromString(object self,string input,number size,string font,number Face,number Bcgrd)
	{
	//Face 	0-standard
	//		1-bold
	//		2-kursive
	//		3-boldkursiv,
	//		4-underlined,
	//		5-boldunderlined
	//		6-kursiveunderlined
	//		7-boldkursivunderlined
	
	//create image surely larger than the annotation size
	if(size<=1) size=1
	number w0 = 2*len(input)*size+20
	number h0 = 2*size+20
	image base:= integerimage("base",1,0,w0,h0)
	base = Bcgrd 
///result("\n"+w0+"x"+h0)

	//create annotation
	number textID = CreateTextAnnotation(base,0,0,input)
	setAnnotationSize(base,textID,size)
	setAnnotationFont(base,textID,font)
	setAnnotationFace(base,textID,Face)
	setAnnotationBackground(base,textID,2)

	//burn annotation and cut the caption area from it
	number top,left,bottom,right
	GetAnnotationRect(base,textID,top,left,bottom,right)
	bottom = trunc(bottom)+1
	right = trunc(right)+1
	
	//NOTE THAT THERE IS A MINIMAL CAPTION SIZE POSSIBLE
//result("\n"+right+"-"+bottom)

	image Merged = blue(CreateImageFromDisplay(base))[top,left,bottom,right]
				
	return Merged
	}

//icon for Settings	button 
image ISet(object self,number size,number Bcgrd,number Rahm)
	{
	image im = self.Ibcgrd(size,Bcgrd)

	im[0.1*size,0.1*size,0.6*size,0.6*size] = 0
	number L=0.07*size,h=0.52*size
	im[L,L,h,h] = tert(iradius<0.1*size,Bcgrd,im[L,L,h,h])
	im = tert(((icol-irow)<0.15*size)&&((icol-irow)>-0.15*size)&&((icol+irow)<0.6*size),Bcgrd,im)
	im = tert(((icol-irow)<0.15*size)&&((icol-irow)>-0.15*size)&&((icol+irow)>0.66*size)&&((icol+irow)<1.6*size),0,im)
	im = tert(((icol-irow)>-0.38*size)&&((icol-irow)<0.38*size),im,Bcgrd)

	return self.IRahm(im,Rahm,Rahm,Bcgrd)
	}

image Imenus(object self,number size,number Bcgrd,number Rahm)
	{		
	image im = self.Ibcgrd(size,Bcgrd)	
	
	number t=0.4*size,l=0*size,b=0.6*size,r=size
	im[t,l,b,r]=0
		
	return self.IRahm(im,Rahm,Rahm,Bcgrd)
	}

image Iplus(object self,number size,number Bcgrd,number Rahm)
	{		
	image im = self.Imenus(size,Bcgrd,Rahm)

	number t=Rahm,l=Rahm+0.4*size,b=t+size,r=l+0.2*size
	im[t,l,b,r]=0
		
	return im
	}

image Iplay(object self,number size,number Bcgrd,number Rahm)
	{		
	image im = self.Ibcgrd(size,0)
	
	im = tert((icol+irow)>1.25*size,Bcgrd,im)
	im = tert((icol-irow)>0.25*size,Bcgrd,im)
	im[0,0,size,0.35*size]=Bcgrd
		
	return self.IRahm(im,Rahm,Rahm,Bcgrd)
	}

image Ipause(object self,number size,number Bcgrd,number Rahm)
	{		
	image im = self.Ibcgrd(size,Bcgrd)
	
	number t=0.15*size, b = 0.85*size
	im[t,0.25*size,b,0.45*size]=0
	im[t,0.55*size,b,0.75*size]=0
		
	return self.IRahm(im,Rahm,Rahm,Bcgrd)
	}

image Iarrow(object self,number dir,number size,number Bcgrd,number Rahm)
	{
	//dir = 0  RIGHT
	//dir = 1  UP
	//dir = 2  LEFT
	//dir = 3  DOWN
				
	image im = self.Ibcgrd(size,0)	

	im = tert((icol+irow)>(1.5*size-1),Bcgrd,im)
	im = tert((icol-irow)>(0.5*size+1),Bcgrd,im)
	im[0,0,size,0.7*size]=Bcgrd
	
	number t=0.4*size,l=0*size,b=0.6*size,r=0.8*size
	im[t,l,b,r]=0
	
	for(number i=0;i<dir;i++) im = rotate(im,1.5708)
	
	return self.IRahm(im,Rahm,Rahm,Bcgrd)
	}
	
//simpliefied bevel button with raised/lowered icon to be same	
TagGroup Button112(object self,image Icon,string Method)	
	{
	return DLGCreateBevelButton(Icon.DLGMakeLowered(),Icon.DLGMakeRaised(),Method)
	}

//This raise/lowers the DLG value by given inrcrement
void RefreshDLGValue112(object self,TagGroup TValue,number increment)
	{
	TValue.DLGValue(TValue.DLGgetValue()+increment)
	}
	
	
/******************Settings**********************/	
//create Setting button Tags in dialogs
TagGroup SettingsButton(object self,number Size,number Bcgrd,string SettingsMethod) 
	{
	image sIcon = self.ISet(Size,Bcgrd,0)
	return self.Button112(sIcon,SettingsMethod)
	}

//make dialog Settings line for one parameter
TagGroup SettingsLine(object self,string Name,TagGroup Param)
	{
	TagGroup Items
	TagGroup Line =DLGCreateDialog("dummy",Items)
	Line.DLGTableLayout(2,1,0)
	Items.DLGaddElement(DLGCreateLabel(Name))
	Items.DLGaddElement(Param.DLGIdentifier(Name))
				
	return Line
	}

number SettingNumberParameter(object self,TagGroup ParamT, string ParamName)
	{
	number Param = ParamT.DLGGetValue()
	self.StoreNumber112(Param,ParamName)
	
	return Param
	}

string SettingStringParameter(object self,TagGroup ParamT, string ParamName)
	{
	string Param = ParamT.DLGGetStringValue()
	self.StoreString112(Param,ParamName)
	
	return Param
	}				
}

	
/******************************************************************
Child UIFrame
******************************************************************/
//this is a child UIFrame created from the mother UIFrame

class ChildUIFrame112: UIFrame112
{
number MotherID //ONLY ID! Mother window as a global makes problem to close the object
number MotherWinExist, MotherWinListeberID

number GetMotherID(object self) return MotherID
void SetMotherID(object self, number ID) MotherID = ID 

//initialization with keeping information about Mother UIFrame object
number initUIFChild112(object self,number MotherIDP,TagGroup FrameTag,string Package,string ChildName)
	{
	MotherID = MotherIDP

	//check mother object
	object Mother = MotherID.GetScriptObjectFromID()
	if(!Mother.scriptObjectIsValid()) return 0
	
	if(!self.initUIFrame112(FrameTag,Package,ChildName)) return 0	
	
	//listen when  the mother UIFrame is closed
	DocumentWindow MotherWin = Mother.GetFrameWindow()
	MotherWinListeberID = MotherWin.WindowAddWindowListener(self,"window_closed:ClosedMotherWindow")
	MotherWinExist =1
	
	return 1
	}

//close the Child if Mother UIFrame is closed	
void ClosedMotherWindow(object self, number e_fl, DocumentWindow Win)
	{	//fired many times after single closing	
	MotherWinExist = 0
	self.SafeCloseUIFrame112()			
	}

//if Child closed, remove listener from MotherWindow  
void RemoveListenerFromMotherWindow112(object self)
	{	
	if(MotherWinExist==1)
		{
		DocumentWindow MotherWin = MotherID.GetScriptObjectFromID().GetFrameWindow()
		MotherWin.WindowRemoveWindowListener(MotherWinListeberID)
		}
	}	
}


/******************************************************************
Redrawer of Dialog window
******************************************************************/
//this is a special object to redraw a frame ON-FLY

class DLGredrawer112:object
{
string Package
string Name

number DialogID	// ID of the frame to be redrawn

void SetFrameName(object self,string NameP) Name = NameP	//this command is compartible with UIFrame112
void SetPackageName(object self,string PackageP) Package = PackageP
	
object init(object self,number DialogIDP)
	{
	self.SetFrameName("acting Redrawer")
	
	DialogID = DialogIDP
	
	return self
	}
	
void Go(object self) {}	//dummy thread

~DLGredrawer112(object self) 
	{
	//Main job is done here: Redrawer is a kamikaze object: doing some job while dying
	object Dialog = DialogID.GetScriptObjectFromID()

	//if redrawer was attached to UIFrame	
	if(Dialog.ScriptObjectIsValid())
		{
		if(Dialog.GetFrameWindow().WindowIsValid()) Dialog.GetFrameWindow().WindowClose(0)	
		Dialog.RedrawnUIFrame112()
		}

	//if redrawer was a dummy stored class
	TagGroup Ptg = GetPersistentTagGroup()
	if(TagGroupDoesTagExist(Ptg,Package+":Kept Class")) 
		{	
		if(len(Name)>6) if(left(Name,6)=="dummy ") 
			{
			SetPersistentNumberNote(Package+":Kept Class:Redrawer",0)
			}
		}
			
result("\nWindow_"+DialogID +" redrawn, redrawer died")
	}
	
}

/******************************************************************
These functions are used in Frame112 but might be usefull for other classes
******************************************************************/

//check if image window is still valid	
number CheckImageWindow112(imageDocument imdoc)
	{
	if(!imdoc.ImageDocumentIsValid()) return 0 	//if imdoc not initialised yet
	
	try {
		imdoc.ImageDocumentGetWindow().WindowIsOpen();
		} 
	catch return 0 	//if window was closed 	

	return 1
	}

//get window from imagedisplay
DocumentWindow getWindowFromImageDisplay112(imagedisplay disp)
{
image im := disp.ImageDisplayGetImage()
imageDocument imdoc = im.ImageGetOrCreateImageDocument()
DocumentWindow win = imdoc.ImageDocumentGetWindow()
	
return win
}

number defaultLinePlotLength112() return 670

number SetDesiredZoom112(imageDocument imdoc, number desiredZoom)
	{
	image im := imdoc.ImageDocumentGetImage(0)
	DocumentWindow Win = imDoc.ImageDocumentShow()
		
	number width,height
	getsize(im,width,height)

	number LinePlotDisp
	try{
	im.SetZoom(desiredZoom);
	width  *= desiredZoom
	height *= desiredZoom
	} 
	catch{
	//This means that image is 1D and displayed as line plot
	LinePlotDisp = 1
	width = defaultLinePlotLength112()
	width *= desiredZoom
	height = width/2		//default setting : hight is twice less width
	break;
	}
	
	WindowSetContentSize(win,width,height);		

	//check if the actual zoom coinsides with the desired
	number ActualZoom
	number Integral = ImageDocumentGetDoIntegralZoom(imdoc)
	//Integral=1 stepped resize, 0 continuous resize
	if(Integral&&!LinePlotDisp)
		{	
//result("\nintegral")
		ActualZoom = im.getZoom()
		//the actual zoom might be lower than the desired	
		number zoomedWidth = trunc(width*ActualZoom)
		number zoomedHeight = trunc(height*ActualZoom)
		
		if(zoomedWidth<width) zoomedWidth = zoomedWidth+1
		else zoomedWidth = Width
		if(zoomedHeight<height*ActualZoom) zoomedHeight = zoomedHeight+1
		else zoomedHeight = Height
//result(" w "+w+" h "+h+" ww "+ww+" wh "+wh)

	win.WindowSetContentSize(zoomedWidth,zoomedHeight)	
		}
	else
		{
		ActualZoom = desiredZoom
		}
		
	return ActualZoom
	}

number GetWindowZoomAndPosition112(imageDocument imdoc,number &Y,number &X,number &Zoom)
	{
	if(CheckImageWindow112(imdoc)!=0)
		{
		image im := imdoc.ImageDocumentGetImage(0)
		documentwindow Win = imdoc.ImageDocumentGetWindow()

		win.WindowGetFramePosition(X,Y)	
		
		try{
		zoom = im.getZoom();
		
		}
		catch{
		number w,h
		win.WindowGetContentSize(w,h)

		zoom = w / defaultLinePlotLength112()
		break;
		}
		
		return 1
		}
	else return 0
	}	
	
number SetWindowZoomAndPosition112(imageDocument imdoc,number Y,number X,number Zoom)
	{
	if(CheckImageWindow112(imdoc)!=0) 
		{
		//check if zoom is reasonable
		if((Zoom<=0)||(zoom>64)) zoom = 1
		
		SetDesiredZoom112(imdoc,Zoom)
	
		documentWindow Win = imdoc.ImageDocumentGetWindow()
		win.WindowSetFramePosition(X,Y)
		
		return 1
		}
	else return 0
	}
	
	
/******************************************************************
Frame112 
******************************************************************/
class Frame112:object
{
//This is effectively a wrap around the ImageDocument for images
//This keeps the position and zoom of the periodically created images like LiveView or FFT
//If an image is dependent on the parent image (e g FFT) it is automatically closed when parent is closed
	string Package	//this is name of whole package
	string Name		//this is name of specific image frame 
	
	imagedocument imdoc
	documentwindow win

	number CloseID


imageDocument GetWrappedImageDocument(object self) return imdoc
DocumentWindow 	GetWrappedDocumentWindow(object self) return win

void SetFrameName(object self,string NameP) Name = NameP
void SetPackageName(object self,string PackageP) Package = PackageP
string GetFrameName(object self) return Name
string GetPackageName(object self) return Package


//initialization of wrap around Image Window
//wrapped image must be initialized and shown before initialisation	
number initFrame112(object self,Imagedocument imdocP,string PackageP,string NameP)
	{
	//set wrapped Imagedocument
	imdoc = imdocP
	
	//set window
	if(!imdoc.CheckImageWindow112())
		{
		result("Image window is not valid !!")
		return 0
		}
	win = imdoc.ImageDOcumentGetWindow()

	//set names
	self.SetPackageName(PackageP)
	self.SetFrameName(NameP)			

	//load and set stored window position and zoom
	number top,left,zoom
	self.LoadFramePositions112(top,left,Name)
	zoom = self.LoadNumber112(1,Name+" Z")
//result("\nloaded TL "+top+" "+left+" Z "+zoom)	
	if(!SetWindowZoomAndPosition112(imdoc,top,left,zoom)) 
		{
		result("Cannot set image window zoom and position")
		return 0
		}
	
	//add listener on closing window, otherwise the object run away
	CloseID = win.WindowAddWindowListener(self,"window_closed:ClosedWindow112")
result("\nFrame112 "+self.ScriptObjectgetID()+" initialized")

	return 1
	}	

void ClosedWindow112(object self, number e_fl, DocumentWindow ThisWin)
	{	//fired many times after single closing		
	
	//store window position and zoom
	number top,left,zoom
	if(GetWindowZoomAndPosition112(imdoc,top,left,zoom))
		{	
		self.StorePoint112(top,left,Name+" TL")
		self.StoreNumber112(zoom,Name+" Z")
		}
	else throw("Cannot set image Window zoom and position")
		
result("\nstored TL "+top+" "+left+" Z "+zoom)

	//fire higher level method if defined
	try{self.CloseWindowUser112();} catch{break;}
	
	//remove closing window listener (otherwise object doesnot run out of scope
	ThisWin.WindowRemoveWindowListener(CloseID)
	}
	
~Frame112(object self) 
	{	
	//fire higher level method if defined
	try{self.CloseFrame112();} catch{break;}
 	
result("\n"+Name+" "+self.ScriptObjectGetID()+" destroyed") 		
	}

}


/******************************************************************
Child Frame
******************************************************************/
class ChildFrame112:Frame112
{
number MotherID
number CloseChildID, CloseMotherID

ImageDocument GetMotherImageDocument(object self) return MotherID.GetImageDocumentByID()

//initialization with keeping information about Mother
number initChildFrame112(object self,imageDocument imdoc,imageDocument mothdoc,string Package,string Name)
	{
	if(!self.initFrame112(imdoc,Package,Name)) return 0
	
	MotherID = mothdoc.ImageDocumentGetID()
	
	//add listener on closing mother window
	if(!mothdoc.CheckImageWindow112()) 
		{
		result("Mother image window is not valid !!")
		return 0
		}
	DocumentWindow mothwin = mothdoc.ImageDocumentGetWindow()
	CloseMotherID = mothwin.WindowAddWindowListener(self,"window_closed:ClosedMotherWindow")

	//add listener on closing own window
	DocumentWindow win = imdoc.ImageDocumentGetWindow()
	CloseChildID  = win.WindowAddWindowListener(self,"window_closed:ClosedChildWindow")
	
	return 1
	}

void ClosedChildWindow(object self, number e_fl, DocumentWindow Win)
	{	//fired many times after single closing			
	try{
		//remove closing window listener
		DocumentWindow winM = MotherID.GetImageDocumentByID().ImageDocumentGetWindow()
		winM.WindowRemoveWindowListener(CloseMotherID)
		
		DocumentWindow win = self.GetWrappedImageDocument().ImageDocumentGetWindow()
		win.WindowRemoveWindowListener(CloseChildID)
		}
	catch{break;}
	}
	
void ClosedMotherWindow(object self, number e_fl, DocumentWindow Win)
	{	//fired many times after single closing			
	try{
		self.GetWrappedImageDocument().ImageDocumentGetWindow().WindowClose(0)
		}
	catch{break;}
	}

}